<template>
    <div>
        <form @submit.prevent="onSubmit">
            <div class="col-md-12">
                <div class="form-group col-md-4" :class="{'has-error': this.errors.name}">
                    <label>Nome<b class="text-danger">*</b></label>
                    <input type="text" class="form-control" v-model="formData.name"/>
                    <label class="error" v-if="this.errors.name">{{errors.name[0]}}</label>
                </div>
                <div class="form-group col-md-4" :class="{'has-error': this.errors.bank_id}">
                    <label>Conta bancaria<b class="text-danger">*</b></label>
                    <select type="text" class="form-control" v-model="formData.bank_id" v-select2>
                        <option value="">--Selecione--</option>
                        <option :value="bank.id" v-for="bank in banks">{{bank.name}}</option>
                    </select>
                    <label class="error" v-if="this.errors.bank_id">{{errors.bank_id[0]}}</label>
                </div>
                <div class="form-group col-md-4" :class="{'has-error': this.errors.confirmacao}">
                    <label>Confirmação automática<b class="text-danger">*</b></label>
                    <select type="text" class="form-control" v-model="formData.confirmacao">
                        <option value="">--Selecione--</option>
                        <option :value="1">Sempre confirmar automaticamente</option>
                        <option :value="0">Nunca confirmar automaticamente</option>
                    </select>
                    <label class="error" v-if="this.errors.confirmacao">{{this.errors.confirmacao[0]}}</label>
                </div>
            </div>

            <div class="col-md-12">
                <div class="form-group col-md-3" :class="{'has-error': this.errors.parcelas}">
                    <label>Número máx. parcelas<b class="text-danger">*</b></label>
                    <input type="number" class="form-control" v-model="formData.parcelas"/>
                    <label class="error" v-if="this.errors.parcelas">{{this.errors.parcelas[0]}}</label>
                </div>

                <div class="form-group col-md-3" :class="{'has-error': this.errors.intervalo}">
                    <label>Intervalo entre parcelas<b class="text-danger">*</b></label>
                    <input type="number" class="form-control" v-model="formData.intervalo"/>
                    <label class="error" v-if="this.errors.intervalo">{{this.errors.intervalo[0]}}</label>
                </div>

                <div class="form-group col-md-3" :class="{'has-error': this.errors.primeira_parcela}">
                    <label>1 parcela <i>(dias)</i><b class="text-danger">*</b></label>
                    <input type="number" class="form-control" v-model="formData.primeira_parcela"/>
                    <label class="error" v-if="this.errors.primeira_parcela">{{this.errors.primeira_parcela[0]}}</label>
                </div>

                <div class="form-group col-md-3" :class="{'has-error': this.errors.taxa_banco}">
                    <label>Taxa banco<b class="text-danger">*</b></label>
                    <div class="input-group">
                        <div class="input-group-addon">
                            R$
                        </div>
                        <money class="form-control" v-model="formData.taxa_banco"></money>
                    </div>
                    <label class="error" v-if="this.errors.taxa_banco">{{errors.taxa_banco[0]}}</label>
                </div>
            </div>

            <div class="col-md-12">
                <div class="form-group col-md-3" :class="{'has-error': this.errors.taxa_operadora}">
                    <label>Taxa operadora <b class="text-danger">*</b></label>
                    <div class="input-group">
                        <money class="form-control" v-model="formData.taxa_operadora"></money>
                        <div class="input-group-addon">
                            %
                        </div>
                    </div>
                    <label class="error" v-if="this.errors.taxa_operadora">{{errors.taxa_operadora[0]}}</label>
                </div>

                <div class="form-group col-md-3" :class="{'has-error': this.errors.multa}">
                    <label>Multa por atraso <b class="text-danger">*</b></label>
                    <div class="input-group">
                        <money class="form-control" v-model="formData.multa"></money>
                        <div class="input-group-addon">
                            %
                        </div>
                    </div>
                    <label class="error" v-if="this.errors.multa">{{this.errors.multa[0]}}</label>
                </div>

                <div class="form-group col-md-3" :class="{'has-error': this.errors.gerar_boleto}">
                    <label>Gera boleto?<b class="text-danger">*</b></label>
                    <select type="text" class="form-control" v-model="formData.gerar_boleto">
                        <option :value="0">Não</option>
                        <option :value="1">Sim</option>
                    </select>
                    <label class="error" v-if="this.errors.gerar_boleto">{{errors.gerar_boleto[0]}}</label>
                </div>
            </div>

            <div class="col-sm-12">
                <div class="hr-line-dashed"></div>
                <button class="btn btn-white" type="button" @click.prevent="backPage" :disabled="isBtnPreload">
                    <i class="fa fa-reply"></i> Voltar
                </button>
                <button class="btn btn-primary" type="submit" :disabled="isBtnPreload">
                    <i v-if="isBtnPreload" class="fa fa-circle-o-notch fa-spin"></i>
                    <i class="fa fa-save" v-else></i>
                    Salvar
                </button>
            </div>
        </form>
    </div>
</template>

<script>
    export default {
        props: {
            isUpdate: {
                require: false,
                type: Boolean,
                default: false,
            },

            formData: {
                require: false,
                type: Object,
                default: () => {
                    return {
                        bank_id: '',
                        name: '',
                        confirmacao: '',
                        parcelas: 12,
                        intervalo: 30,
                        primeira_parcela: 0,
                        taxa_banco: 0,
                        taxa_operadora: 0,
                        multa: 0,
                        gerar_boleto: 0,
                    }
                }
            }
        },
        data() {
            return {
                banks: '',
                errors: {
                    bank_id: '',
                    name: '',
                    confirmacao: '',
                    parcelas: '',
                    intervalo: '',
                    primeira_parcela: '',
                    taxa_banco: '',
                    taxa_operadora: '',
                    multa: '',
                    gerar_boleto: '',
                }
            }
        },

        created() {
            this.loadBanks()
        },

        computed: {
            isBtnPreload() {
                return this.$store.state.preload.btnLoading
            },
        },

        methods: {
            loadBanks() {
                this.$store.dispatch('loadBanks')
                    .then((response) => {
                        this.banks = response
                    })
            },
            onSubmit() {
                const action = this.isUpdate ? 'updatePayment' : 'storePayment'
                const msg = this.isUpdate ? 'Forma de pagamento editada com sucesso' :
                    'Cadastro de forma de pagamento feita com sucesso'
                this.$store.dispatch(action, this.formData)
                    .then(() => {
                        this.$snotify.success(msg)
                        this.$router.push({name: 'payments'})
                    })
                    .catch((error) => {
                        this.errors = error.response.data.errors
                    })
            },

            backPage() {
                return this.$router.push({name: 'payments'})
            }
        }
    }
</script>